/* 
    ssft - is a simple file transfer program that use SSL (Secure 
    Socket Layer) encryption to secure the transfers - and 
    signed certificates to authenticate users and servers. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/
#ifndef FILE_INFO_H
#define FILE_INFO_H

class FileInfo
{
public:
    
    FileInfo()
    {}

    FileInfo(const FileInfo& from)
        : mName(from.mName),
        mType(from.mType),
        mHash(from.mHash),
        mLength(from.mLength),
        mDate(from.mDate)
    {}

    bool operator < (const FileInfo& from) const
    {
        return mName < from.mName;
    }

    bool operator == (const FileInfo& from) const
    {
        return mName == from.mName;
    }

    FileInfo& operator = (const FileInfo& from)
    {
        mName = from.mName;
        mType = from.mType;
        mHash = from.mHash;
        mLength = from.mLength;
        mDate = from.mDate;

	return *this;
    }

    std::string mName;
    DirNodeTypesE mType;
    std::string mHash;
    ssft_flen_t mLength;
    ssft_date_t mDate;
};

typedef std::set<FileInfo> fileset_t;

#endif // FILE_INFO_H
