/* 
    ssft - is a simple file transfer program that use SSL (Secure 
    Socket Layer) encryption to secure the transfers - and 
    signed certificates to authenticate users and servers. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/


#include "StdAfx.h"
#include "ssft.h"
#include "MyNtService.h"
#include <malloc.h>

extern int do_process(int argc, char **argv);
extern bool do_continue;
extern const char *service_name;

MyNtService::MyNtService()
: CNTService(service_name)
{
}

int MyNtService::GetRegistryValue(HKEY root, 
        const char *key, 
        const char *value, 
        char *return_buf, 
        DWORD *return_buf_len)
{
    size_t tmp_len;
	DWORD error_status;
	HKEY registry_handle;
	char *tmp_buffer;
	DWORD key_type = 0;
	if ((error_status = RegOpenKeyEx(
		root, key, 0, KEY_QUERY_VALUE, &registry_handle)) == ERROR_SUCCESS) {
		if ((error_status = RegQueryValueEx(registry_handle, value, NULL, 
			&key_type, (LPBYTE)return_buf, return_buf_len)) == ERROR_SUCCESS) {
			if (key_type == REG_EXPAND_SZ) {
				tmp_len = strlen(return_buf) + 256;
				tmp_buffer = (char *)alloca(tmp_len);
				error_status = ExpandEnvironmentStrings(return_buf, tmp_buffer, 
					tmp_len);
				strcpy(return_buf, tmp_buffer);
			}
		}
		RegCloseKey(registry_handle);
	}
	
	if (error_status == ERROR_SUCCESS)
		return 0;
	
	return -1;
}

void MyNtService::OnStop()
{
    do_continue = false;
}

void MyNtService::Run()
{
    log << LOG_DATE << "Now running as a native NT service." << ENDL;
    do_process(0, NULL);
    log << LOG_DATE << "Leaving NT service mode (stopping)." << ENDL;
}

