/* 
    ssft - is a simple file transfer program that use SSL (Secure 
    Socket Layer) encryption to secure the transfers - and 
    signed certificates to authenticate users and servers. 

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

    Copyright 2001 - 2002 by Jarle (jgaa) Aase, jgaa@jgaa.com
    http://www.jgaa.com

*/

#include "StdAfx.h"
#include "ssft.h"
#include <assert.h>

/*
**  XSTRCMP.C - Simple string pattern matching functions using DOS
**              wildcards ('?' & '*').
**
**  Derived from code by Arjan Kentner (submitted by Steve Summit),
**  modified by Bob Stout.
**
** http://www.snippets.org/snippets/dos/XSTRCMP+C.php3
*/



using namespace std;

static bool patmat(const char *pattern, const char *str)
{
    switch (*pattern)
    {
    case '\0':
        return !*str;
        
    case '*' :
        return patmat(pattern+1, str) 
            || *str && patmat(pattern, str+1);
        
    case '?' :
        return *str && patmat(pattern+1, str+1);
        
    default  :
        return (*pattern == *str) 
            && patmat(pattern+1, str+1);
    }
}

bool xstrcmp(const char *pattern, const char *str)
{
    assert(str && pattern);
    if (NULL == str || NULL == pattern)
        return false;
    else  
        return(patmat(pattern, str));
}


static bool patimat(const char *pattern, const char *str)
{
    switch (*pattern)
    {
    case '\0':
        return !*str;
        
    case '*' :
        return patimat(pattern+1, str) 
            || *str && patimat(pattern, str+1);
        
    case '?' :
        return *str && patimat(pattern+1, str+1);
        
    default  :
        return (toupper(*pattern) == toupper(*str)) 
            && patimat(pattern+1, str+1);
    }
}

bool xstricmp(const char *pattern, const char *str)
{
    assert(str && pattern);
    
    if (NULL == str || NULL == pattern)
        return false;
    else  
        return(patimat(pattern, str));
}
