

#ifndef GETOPT_H_INCLUDED
#define GETOPT_H_INCLUDED

#ifdef __cplusplus
extern "C"
{
#endif /* __cplusplus */

    /* ---------------- START OF C HEADER -------------- */

    int getopt_long(int argc,
                    char * const argv[],
                    const char *optstring,
                    const struct option *longopts,
                    int *longindex);

    struct option
    {
        const char *name;
        int has_arg;
        int *flag;
        int val;
    };

    enum {no_argument, required_argument, optional_argument};

    extern const char *ports_optarg;
    extern int ports_optind, ports_opterr, ports_optopt;

#define optarg ports_optarg
#define optind ports_optind
#define opter ports_opterr
#define optopt ports_optopt

    /* ---------------- END OF C HEADER -------------- */
#ifdef __cplusplus
}
#endif /* __cplusplus */
#endif /* GETOPT_H_INCLUDED */

